require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&AMDPM_CONFREG)) {
    sub AMDPM_CONFREG () {	0x40;}
}
unless(defined(&AMDPM_RNGEN)) {
    sub AMDPM_RNGEN () {	0x80;}
}
unless(defined(&AMDPM_STOPTMR)) {
    sub AMDPM_STOPTMR () {	0x40;}
}
unless(defined(&AMDPM_PMIOEN)) {
    sub AMDPM_PMIOEN () {	0x8000;}
}
unless(defined(&AMDPM_TMRRST)) {
    sub AMDPM_TMRRST () {	0x4000;}
}
unless(defined(&AMDPM_TMR32)) {
    sub AMDPM_TMR32 () {	0x800;}
}
unless(defined(&AMDPM_PMPTR)) {
    sub AMDPM_PMPTR () {	0x58;}
}
unless(defined(&NFPM_PMPTR)) {
    sub NFPM_PMPTR () {	0x14;}
}
unless(defined(&AMDPM_PMBASE)) {
    sub AMDPM_PMBASE {
	local($x) = @_;
	eval q((($x) & 0xff00));
    }
}
unless(defined(&AMDPM_PMSIZE)) {
    sub AMDPM_PMSIZE () {	256;}
}
unless(defined(&AMDPM_TMR)) {
    sub AMDPM_TMR () {	0x8;}
}
unless(defined(&AMDPM_RNGDATA)) {
    sub AMDPM_RNGDATA () {	0xf0;}
}
unless(defined(&AMDPM_RNGSTAT)) {
    sub AMDPM_RNGSTAT () {	0xf4;}
}
unless(defined(&AMDPM_RNGDONE)) {
    sub AMDPM_RNGDONE () {	0x1;}
}
unless(defined(&AMDPM_SMBSTAT)) {
    sub AMDPM_SMBSTAT () {	0xe0;}
}
unless(defined(&AMDPM_SMBSTAT_ABRT)) {
    sub AMDPM_SMBSTAT_ABRT () {	(1<< 0);}
}
unless(defined(&AMDPM_SMBSTAT_COL)) {
    sub AMDPM_SMBSTAT_COL () {	(1<< 1);}
}
unless(defined(&AMDPM_SMBSTAT_PRERR)) {
    sub AMDPM_SMBSTAT_PRERR () {	(1<< 2);}
}
unless(defined(&AMDPM_SMBSTAT_HBSY)) {
    sub AMDPM_SMBSTAT_HBSY () {	(1<< 3);}
}
unless(defined(&AMDPM_SMBSTAT_CYC)) {
    sub AMDPM_SMBSTAT_CYC () {	(1<< 4);}
}
unless(defined(&AMDPM_SMBSTAT_TO)) {
    sub AMDPM_SMBSTAT_TO () {	(1<< 5);}
}
unless(defined(&AMDPM_SMBSTAT_SNP)) {
    sub AMDPM_SMBSTAT_SNP () {	(1<< 8);}
}
unless(defined(&AMDPM_SMBSTAT_SLV)) {
    sub AMDPM_SMBSTAT_SLV () {	(1<< 9);}
}
unless(defined(&AMDPM_SMBSTAT_SMBA)) {
    sub AMDPM_SMBSTAT_SMBA () {	(1<< 10);}
}
unless(defined(&AMDPM_SMBSTAT_BSY)) {
    sub AMDPM_SMBSTAT_BSY () {	(1<< 11);}
}
unless(defined(&AMDPM_SMBSTAT_BITS)) {
    sub AMDPM_SMBSTAT_BITS () {	"\020\001ABRT\002COL\003PRERR\004HBSY\005CYC\006TO\011SNP\012SLV\013SMBA\014BSY";}
}
unless(defined(&AMDPM_SMBCTL)) {
    sub AMDPM_SMBCTL () {	0xe2;}
}
unless(defined(&AMDPM_SMBCTL_CMD_QUICK)) {
    sub AMDPM_SMBCTL_CMD_QUICK () {	0;}
}
unless(defined(&AMDPM_SMBCTL_CMD_BYTE)) {
    sub AMDPM_SMBCTL_CMD_BYTE () {	1;}
}
unless(defined(&AMDPM_SMBCTL_CMD_BDATA)) {
    sub AMDPM_SMBCTL_CMD_BDATA () {	2;}
}
unless(defined(&AMDPM_SMBCTL_CMD_WDATA)) {
    sub AMDPM_SMBCTL_CMD_WDATA () {	3;}
}
unless(defined(&AMDPM_SMBCTL_CMD_PCALL)) {
    sub AMDPM_SMBCTL_CMD_PCALL () {	4;}
}
unless(defined(&AMDPM_SMBCTL_CMD_BLOCK)) {
    sub AMDPM_SMBCTL_CMD_BLOCK () {	5;}
}
unless(defined(&AMDPM_SMBCTL_START)) {
    sub AMDPM_SMBCTL_START () {	(1<< 3);}
}
unless(defined(&AMDPM_SMBCTL_CYCEN)) {
    sub AMDPM_SMBCTL_CYCEN () {	(1<< 4);}
}
unless(defined(&AMDPM_SMBCTL_ABORT)) {
    sub AMDPM_SMBCTL_ABORT () {	(1<< 5);}
}
unless(defined(&AMDPM_SMBCTL_SNPEN)) {
    sub AMDPM_SMBCTL_SNPEN () {	(1<< 8);}
}
unless(defined(&AMDPM_SMBCTL_SLVEN)) {
    sub AMDPM_SMBCTL_SLVEN () {	(1<< 9);}
}
unless(defined(&AMDPM_SMBCTL_SMBAEN)) {
    sub AMDPM_SMBCTL_SMBAEN () {	(1<< 10);}
}
unless(defined(&AMDPM_SMBADDR)) {
    sub AMDPM_SMBADDR () {	0xe4;}
}
unless(defined(&AMDPM_SMBADDR_READ)) {
    sub AMDPM_SMBADDR_READ () {	(1<< 0);}
}
unless(defined(&AMDPM_SMBADDR_ADDR)) {
    sub AMDPM_SMBADDR_ADDR {
	local($x) = @_;
	eval q(((($x) & 0x7f) << 1));
    }
}
unless(defined(&AMDPM_SMBDATA)) {
    sub AMDPM_SMBDATA () {	0xe6;}
}
unless(defined(&AMDPM_SMBCMD)) {
    sub AMDPM_SMBCMD () {	0xe8;}
}
1;
