require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&EHCI_SQTD_SIZE)) {
    sub EHCI_SQTD_SIZE () {	(($sizeof{'struct ehci_soft_qtd'} +  &EHCI_QTD_ALIGN - 1) /  &EHCI_QTD_ALIGN *  &EHCI_QTD_ALIGN);}
}
unless(defined(&EHCI_SQTD_CHUNK)) {
    sub EHCI_SQTD_CHUNK () {	( &EHCI_PAGE_SIZE /  &EHCI_SQTD_SIZE);}
}
unless(defined(&EHCI_SQH_SIZE)) {
    sub EHCI_SQH_SIZE () {	(($sizeof{'struct ehci_soft_qh'} +  &EHCI_QH_ALIGN - 1) /  &EHCI_QH_ALIGN *  &EHCI_QH_ALIGN);}
}
unless(defined(&EHCI_SQH_CHUNK)) {
    sub EHCI_SQH_CHUNK () {	( &EHCI_PAGE_SIZE /  &EHCI_SQH_SIZE);}
}
if(defined(&DIAGNOSTIC)) {
}
unless(defined(&EXFER)) {
    sub EXFER {
	local($xfer) = @_;
	eval q((($xfer)));
    }
}
unless(defined(&EHCI_FRAMELIST_MAXCOUNT)) {
    sub EHCI_FRAMELIST_MAXCOUNT () {	1024;}
}
unless(defined(&EHCI_IPOLLRATES)) {
    sub EHCI_IPOLLRATES () {	8;}
}
unless(defined(&EHCI_INTRQHS)) {
    sub EHCI_INTRQHS () {	((1<<  &EHCI_IPOLLRATES) - 1);}
}
unless(defined(&EHCI_IQHIDX)) {
    sub EHCI_IQHIDX {
	local($lev, $pos) = @_;
	eval q((((($pos) & ((1<< ($lev)) - 1)) | (1<< ($lev))) - 1));
    }
}
unless(defined(&EHCI_ILEV_IVAL)) {
    sub EHCI_ILEV_IVAL {
	local($lev) = @_;
	eval q((1<< ($lev)));
    }
}
unless(defined(&EHCI_HASH_SIZE)) {
    sub EHCI_HASH_SIZE () {	128;}
}
unless(defined(&EHCI_COMPANION_MAX)) {
    sub EHCI_COMPANION_MAX () {	8;}
}
unless(defined(&EHCIF_DROPPED_INTR_WORKAROUND)) {
    sub EHCIF_DROPPED_INTR_WORKAROUND () {	0x1;}
}
unless(defined(&EREAD1)) {
    sub EREAD1 {
	local($sc, $a) = @_;
	eval q( &bus_space_read_1(($sc)-> &iot, ($sc)-> &ioh, ($a)));
    }
}
unless(defined(&EREAD2)) {
    sub EREAD2 {
	local($sc, $a) = @_;
	eval q( &bus_space_read_2(($sc)-> &iot, ($sc)-> &ioh, ($a)));
    }
}
unless(defined(&EREAD4)) {
    sub EREAD4 {
	local($sc, $a) = @_;
	eval q( &bus_space_read_4(($sc)-> &iot, ($sc)-> &ioh, ($a)));
    }
}
unless(defined(&EWRITE1)) {
    sub EWRITE1 {
	local($sc, $a, $x) = @_;
	eval q( &bus_space_write_1(($sc)-> &iot, ($sc)-> &ioh, ($a), ($x)));
    }
}
unless(defined(&EWRITE2)) {
    sub EWRITE2 {
	local($sc, $a, $x) = @_;
	eval q( &bus_space_write_2(($sc)-> &iot, ($sc)-> &ioh, ($a), ($x)));
    }
}
unless(defined(&EWRITE4)) {
    sub EWRITE4 {
	local($sc, $a, $x) = @_;
	eval q( &bus_space_write_4(($sc)-> &iot, ($sc)-> &ioh, ($a), ($x)));
    }
}
unless(defined(&EOREAD1)) {
    sub EOREAD1 {
	local($sc, $a) = @_;
	eval q( &bus_space_read_1(($sc)-> &iot, ($sc)-> &ioh, ($sc)-> &sc_offs+($a)));
    }
}
unless(defined(&EOREAD2)) {
    sub EOREAD2 {
	local($sc, $a) = @_;
	eval q( &bus_space_read_2(($sc)-> &iot, ($sc)-> &ioh, ($sc)-> &sc_offs+($a)));
    }
}
unless(defined(&EOREAD4)) {
    sub EOREAD4 {
	local($sc, $a) = @_;
	eval q( &bus_space_read_4(($sc)-> &iot, ($sc)-> &ioh, ($sc)-> &sc_offs+($a)));
    }
}
unless(defined(&EOWRITE1)) {
    sub EOWRITE1 {
	local($sc, $a, $x) = @_;
	eval q( &bus_space_write_1(($sc)-> &iot, ($sc)-> &ioh, ($sc)-> &sc_offs+($a), ($x)));
    }
}
unless(defined(&EOWRITE2)) {
    sub EOWRITE2 {
	local($sc, $a, $x) = @_;
	eval q( &bus_space_write_2(($sc)-> &iot, ($sc)-> &ioh, ($sc)-> &sc_offs+($a), ($x)));
    }
}
unless(defined(&EOWRITE4)) {
    sub EOWRITE4 {
	local($sc, $a, $x) = @_;
	eval q( &bus_space_write_4(($sc)-> &iot, ($sc)-> &ioh, ($sc)-> &sc_offs+($a), ($x)));
    }
}
1;
